//
//  Controller.m
//  TicTacToe
//
//  Created by Ivo Npflin on Tue Mar 04 2003.
//  Copyright (c) 2003 Ivo Npflin. All rights reserved.
//

#import "TicTacToe.h"
#import "Controller.h"

@implementation Controller

- (IBAction)A1:(id)sender
{
    [MoveNotPossible orderOut:0];
    [TicTacToeEng Move:1 User:4];
}

- (IBAction)A2:(id)sender
{
    [MoveNotPossible orderOut:0];
    [TicTacToeEng Move:2 User:4];
}

- (IBAction)A3:(id)sender
{
    [MoveNotPossible orderOut:0];
    [TicTacToeEng Move:3 User:4];
}

- (IBAction)B1:(id)sender
{
    [MoveNotPossible orderOut:0];
    [TicTacToeEng Move:4 User:4];
}

- (IBAction)B2:(id)sender
{
    [MoveNotPossible orderOut:0];
    [TicTacToeEng Move:5 User:4];
}

- (IBAction)B3:(id)sender
{
    [MoveNotPossible orderOut:0];
    [TicTacToeEng Move:6 User:4];
}

- (IBAction)C1:(id)sender
{
    [MoveNotPossible orderOut:0];
    [TicTacToeEng Move:7 User:4];
}

- (IBAction)C2:(id)sender
{
    [MoveNotPossible orderOut:0];
    [TicTacToeEng Move:8 User:4];
}

- (IBAction)C3:(id)sender
{
    [MoveNotPossible orderOut:0];
    [TicTacToeEng Move:9 User:4];
}

- (IBAction)New:(id)sender
{
    NSString *Pathempty = @"empty.tiff";
    NSImage *empty = [NSImage imageNamed:Pathempty]; 
    [A1 setImage:empty];
    [A2 setImage:empty];
    [A3 setImage:empty];
    [B1 setImage:empty];
    [B2 setImage:empty];
    [B3 setImage:empty];
    [C1 setImage:empty];
    [C2 setImage:empty];
    [C3 setImage:empty];
    [TicTacToeEng ClearEntries:0];
    [Win orderOut:0];
    [Draw orderOut:0];
    [Lose orderOut:0];
    [MoveNotPossible orderOut:0];
    [ClearStats orderOut:0];
    [Stats orderOut:0];
}

- (IBAction)Easy:(id)sender
{
    [Easy setState:NSOnState];
    [Medium setState:NSOffState];
    [Hard setState:NSOffState];
    [Impossible setState:NSOffState];
    Difficulty = 1;
    [[NSUserDefaults standardUserDefaults] setInteger:1 forKey:@"Difficulty"];

}

- (IBAction)Medium:(id)sender
{
    [Easy setState:NSOffState];
    [Medium setState:NSOnState];
    [Hard setState:NSOffState];
    [Impossible setState:NSOffState];
    Difficulty = 2;
    [[NSUserDefaults standardUserDefaults] setInteger:2 forKey:@"Difficulty"];
}

- (IBAction)Hard:(id)sender
{
    [Easy setState:NSOffState];
    [Medium setState:NSOffState];
    [Hard setState:NSOnState];
    [Impossible setState:NSOffState];
    Difficulty = 3;
    [[NSUserDefaults standardUserDefaults] setInteger:3 forKey:@"Difficulty"];
}

- (IBAction)Impossible:(id)sender
{
    [Easy setState:NSOffState];
    [Medium setState:NSOffState];
    [Hard setState:NSOffState];
    [Impossible setState:NSOnState];
    Difficulty = 4;
    [[NSUserDefaults standardUserDefaults] setInteger:4 forKey:@"Difficulty"];
}


- (IBAction)Move:(short)Where User:(short)Who
{
    if (Who == 1)
    {
        NSString *Path = @"circle";
        NSImage *MyImage = [NSImage imageNamed:Path];
        if (Where == 1) [A1 setImage:MyImage];
        if (Where == 2) [A2 setImage:MyImage];
        if (Where == 3) [A3 setImage:MyImage];
        if (Where == 4) [B1 setImage:MyImage];
        if (Where == 5) [B2 setImage:MyImage];
        if (Where == 6) [B3 setImage:MyImage];
        if (Where == 7) [C1 setImage:MyImage];
        if (Where == 8) [C2 setImage:MyImage];
        if (Where == 9) [C3 setImage:MyImage];
    }
    else
    {
        NSString *Path = @"cross";
        NSImage *MyImage = [NSImage imageNamed:Path];
        if (Where == 1) [A1 setImage:MyImage];
        if (Where == 2) [A2 setImage:MyImage];
        if (Where == 3) [A3 setImage:MyImage];
        if (Where == 4) [B1 setImage:MyImage];
        if (Where == 5) [B2 setImage:MyImage];
        if (Where == 6) [B3 setImage:MyImage];
        if (Where == 7) [C1 setImage:MyImage];
        if (Where == 8) [C2 setImage:MyImage];
        if (Where == 9) [C3 setImage:MyImage];
    }
}
- (void)Win
{
    [Win makeKeyAndOrderFront:0];
}

- (void)Lose
{
    [Lose makeKeyAndOrderFront:0];
}

- (void)Draw
{
    [Draw makeKeyAndOrderFront:0];
}

- (void)MoveNotPossible
{
    [MoveNotPossible makeKeyAndOrderFront:0];
}

- (short)Difficulty
{
    if (Difficulty != 1 && Difficulty != 2 && Difficulty != 3 && Difficulty != 4)
    {
        Difficulty = [[NSUserDefaults standardUserDefaults] integerForKey:@"Difficulty"];
        if (Difficulty == 1)
        {
            [self Easy:0];
        }
        else
        {
            if (Difficulty == 2)
            {
                [self Medium:0];
            }
            else
            {
                if (Difficulty == 3)
                {
                    [self Hard:0];
                }
                else
                {
                    if (Difficulty == 4)
                    {
                        [self Impossible:0];
                    }
                    else
                    {
                        Difficulty = 4;
                    }
                }
            }
        }            
    }
    return Difficulty;
}

- (void)awakeFromNib
{
    [self Difficulty];
}

- (IBAction)ClearStats:(id)sender
{
    [self StatsPlusAt:0];
}

- (IBAction)StatsPlusAt:(short)Result;
{/*
    NSString *StatsPfad = @"Stats";
    NSMutableDictionary *Results = [[NSMutableDictionary alloc] initWithDictionary:[[NSUserDefaults standardUserDefaults] dictionaryForKey:StatsPfad]];
    NSMutableArray *ResultsNSNumber = [[NSMutableArray alloc] initWithCapacity:8];
    
    if ([Results objectForKey:@"DrawBegin"] == nil)
        [ResultsNSNumber replaceObjectAtIndex:1 withObject:[NSNumber numberWithInt:0]];
    else 
        [ResultsNSNumber replaceObjectAtIndex:1 withObject:[Results objectForKey:@"DrawBegin"]];

    if ([Results objectForKey:@"WinBegin"] == nil)
        [ResultsNSNumber replaceObjectAtIndex:2 withObject:[NSNumber numberWithInt:0]];
    else
        [ResultsNSNumber replaceObjectAtIndex:2 withObject:[Results objectForKey:@"DrawBegin"]];

    if ([Results objectForKey:@"LoseBegin"] == nil)
        [ResultsNSNumber replaceObjectAtIndex:3 withObject:[NSNumber numberWithInt:0]];
    else
        [ResultsNSNumber replaceObjectAtIndex:3 withObject:[Results objectForKey:@"DrawBegin"]];

    if ([Results objectForKey:@"DrawNBegin"] == nil)
        [ResultsNSNumber replaceObjectAtIndex:4 withObject:[NSNumber numberWithInt:0]];
    else
        [ResultsNSNumber replaceObjectAtIndex:4 withObject:[Results objectForKey:@"DrawBegin"]];

    if ([Results objectForKey:@"WinNBegin"] == nil)
        [ResultsNSNumber replaceObjectAtIndex:5 withObject:[NSNumber numberWithInt:0]];
    else
        [ResultsNSNumber replaceObjectAtIndex:5 withObject:[Results objectForKey:@"DrawBegin"]];
        
    if ([Results objectForKey:@"LoseNBegin"] == nil)
        [ResultsNSNumber replaceObjectAtIndex:6 withObject:[NSNumber numberWithInt:0]];
    else
        [ResultsNSNumber replaceObjectAtIndex:6 withObject:[Results objectForKey:@"DrawBegin"]];
        
    [DrawBegin setStringValue:@"hallo"];
        
    if(Result == 0)
    {
        [ResultsNSNumber replaceObjectAtIndex:1 withObject:[NSNumber numberWithInt:0]];
        [ResultsNSNumber replaceObjectAtIndex:2 withObject:[NSNumber numberWithInt:0]];
        [ResultsNSNumber replaceObjectAtIndex:3 withObject:[NSNumber numberWithInt:0]];
        [ResultsNSNumber replaceObjectAtIndex:4 withObject:[NSNumber numberWithInt:0]];
        [ResultsNSNumber replaceObjectAtIndex:5 withObject:[NSNumber numberWithInt:0]];
        [ResultsNSNumber replaceObjectAtIndex:6 withObject:[NSNumber numberWithInt:0]];
    }
    else
    {
        int Old = [[ResultsNSNumber objectAtIndex:Result] intValue];
        Old++;
        [ResultsNSNumber replaceObjectAtIndex:Result withObject:[NSNumber numberWithInt:Old]];
    }
    [ResultsNSNumber release];
    [Results release];
    */
}

@end
