//
//  TicTacToe.m
//  TicTacToe
//
//  Created by Ivo Npflin on Tue Mar 04 2003.
//  Copyright (c) 2003 Ivo Npflin. All rights reserved.
//

#import "TicTacToe.h"
#import "Controller.h"

@implementation TicTacToe

- (IBAction)Move:(short)Where User:(short)Who
{
    if (MoveNumber == 0)
    {
        Difficulty = [controller Difficulty];
    }
    
    if ([self WinnerAlready])
    {
        [controller New:0];
        if (PlayerBegins == NO)
            [self Move:Where User:Who];
    }
    
    else
    {
        if (Setting[Where] == 0)
            {
                Setting[Where] = Who;
                [controller Move:Where User:Who];
                if (Where != 0) MoveNumber++;
                if ([self WinnerAlready] == 0)
                {
                    if (Who == 4)
                    {
                        WhereComp = 0;
                        [self StartCalculationCompMove];
                        MoveNumber++;
                    }
                }
            }
        else
            [controller MoveNotPossible];
    }
}

- (void)StartCalculationCompMove
{
    if (Difficulty == 4)
    {
        if (MoveNumber < 2)
        {
            [self Scheme];
        }
        else
        {
            if ([self RowCheck:1] == 0)
            {
                if ([self RowCheck:0] == 0)
                {
                    if ([self CrossCheck] == 0)
                    {
                        if ([self L7andL8Check] == 0)
                        {
                            if ([self L1toL6Check] == 0)
                            {
                                [self RandomMove];
                            }
                        }
                    }
                }
            }
        }
    }
    
    if (Difficulty == 3)
    {
        if (MoveNumber == 1)
        {
            [self Scheme];
        }
        else
        {
            if ([self RowCheck:1] == 0)
            {
                if ([self RowCheck:0] == 0)
                {
                    [self RandomMove];
                }
            }
        }
    }
    
    if (Difficulty == 2)
    {
        if ([self RowCheck:1] == 0)
        {
            if ([self RowCheck:0] == 0)
            {
                [self RandomMove];
            }
        }
    }
    
    if (Difficulty == 1)
    {
        [self RandomMove];
    }
    [self Move:WhereComp User:1];
}

- (IBAction)Scheme
{
    if (MoveNumber == 0)
    {
        short Possibility[4];
        Possibility[0] = 1;
        Possibility[1] = 3;
        Possibility[2] = 7;
        Possibility[3] = 9;
        Possibility[4] = 5;
        WhereComp = Possibility[random()%5];
    }
    else
    {
        if (Setting[5] == 4)
        {
            short Possibility[3];
            Possibility[0] = 1;
            Possibility[1] = 3;
            Possibility[2] = 7;
            Possibility[3] = 9;
            WhereComp = Possibility[random()%4];
        }
        else
        {
            WhereComp = 5;
        }
    }
}



- (BOOL)RowCheck:(BOOL)Done
{
    short Counter;
    if (Done) {Counter=2;}
    else {Counter=8;}

    if([self Row:1]==Counter)
    {
        if(Setting[1]==0){WhereComp = 1; return true;}
        if(Setting[2]==0){WhereComp = 2; return true;}
        if(Setting[3]==0){WhereComp = 3; return true;}
    }

    if([self Row:2]==Counter)
    {
        if(Setting[4]==0){WhereComp = 4; return true;}
        if(Setting[5]==0){WhereComp = 5; return true;}
        if(Setting[6]==0){WhereComp = 6; return true;}
    }

    if([self Row:3]==Counter)
    {
        if(Setting[7]==0){WhereComp = 7; return true;}
        if(Setting[8]==0){WhereComp = 8; return true;}
        if(Setting[9]==0){WhereComp = 9; return true;}
    }

    if([self Row:4]==Counter)
    {
        if(Setting[1]==0){WhereComp = 1; return true;}
        if(Setting[4]==0){WhereComp = 4; return true;}
        if(Setting[7]==0){WhereComp = 7; return true;}
    }

    if([self Row:5]==Counter)
    {
        if(Setting[2]==0){WhereComp = 2; return true;}
        if(Setting[5]==0){WhereComp = 5; return true;}
        if(Setting[8]==0){WhereComp = 8; return true;}
    }

    if([self Row:6]==Counter)
    {
        if(Setting[3]==0){WhereComp = 3; return true;}
        if(Setting[6]==0){WhereComp = 6; return true;}
        if(Setting[9]==0){WhereComp = 9; return true;}
    }

    if([self Row:7]==Counter)
    {
        if(Setting[1]==0){WhereComp = 1; return true;}
        if(Setting[5]==0){WhereComp = 5; return true;}
        if(Setting[9]==0){WhereComp = 9; return true;}
    }

    if([self Row:8]==Counter)
    {
        if(Setting[3]==0){WhereComp = 3; return true;}
        if(Setting[5]==0){WhereComp = 5; return true;}
        if(Setting[7]==0){WhereComp = 7; return true;}
    }
    return false;
}



- (BOOL)L7andL8Check;
{
    short List[2];
    List[0] = 0;
    List[1] = 0;
    short Counter = 0;
    if ([self Row:7] == 1)
    {
        if (random()%2 == 1) {List[Counter] = 1; Counter++;}
        else {List[Counter] = 9; Counter++;}
    }
    if ([self Row:8] == 1)
    {
        if (random()%2 == 1) {List[Counter] = 7; Counter++;}
        else {List[Counter] = 3; Counter++;}
    }
    if (Counter == 0) return false;
    else 
    {
        WhereComp = List[random()%Counter];
        return true;
    }
}

- (void)RandomMove;
{

    short List[10];
    short CounterList = 0;
    short CounterSetting = 1;
    while (CounterSetting < 10)
    {
        if (Setting[CounterSetting] == 0)
        {
            List[CounterList] = CounterSetting;
            CounterList++;
        }
        CounterSetting++;
    }
    
    WhereComp = List[random()%CounterList];

}
- (BOOL)L1toL6Check;
{

    BOOL List[10];
    List[1] = 0;
    List[2] = 0;
    List[3] = 0;
    List[4] = 0;
    List[5] = 0;
    List[6] = 0;
    List[7] = 0;
    List[8] = 0;
    List[9] = 0;
    BOOL checker = 0;
    
    if([self Row:4] == 4)
    {
        if(Setting[1] == 4) {List[4] = 1; List[7] = 1; checker = 1;}
        if(Setting[4] == 4) {List[7] = 1; List[1] = 1; checker = 1;}
        if(Setting[7] == 4) {List[4] = 1; List[1] = 1; checker = 1;}
    }

    if([self Row:2] == 4)
    {
        if(Setting[6] == 4) {List[5] = 1; List[4] = 1; checker = 1;}
        if(Setting[5] == 4) {List[4] = 1; List[6] = 1; checker = 1;}
        if(Setting[4] == 4) {List[5] = 1; List[6] = 1; checker = 1;}
    }

    if([self Row:6] == 4)
    {
        if(Setting[3] == 4) {List[6] = 1; List[9] = 1; checker = 1;}
        if(Setting[6] == 4) {List[9] = 1; List[3] = 1; checker = 1;}
        if(Setting[9] == 4) {List[6] = 1; List[3] = 1; checker = 1;}
    }

    if([self Row:3] == 4)
    {
        if(Setting[9] == 4) {List[8] = 1; List[7] = 1; checker = 1;}
        if(Setting[8] == 4) {List[7] = 1; List[9] = 1; checker = 1;}
        if(Setting[7] == 4) {List[8] = 1; List[9] = 1; checker = 1;}
    }

    if([self Row:5] == 4)
    {
        if(Setting[2] == 4) {List[5] = 1; List[8] = 1; checker = 1;}
        if(Setting[5] == 4) {List[8] = 1; List[2] = 1; checker = 1;}
        if(Setting[8] == 4) {List[5] = 1; List[2] = 1; checker = 1;}
    }

    if([self Row:1] == 4)
    {
        if(Setting[3] == 4) {List[2] = 1; List[1] = 1; checker = 1;}
        if(Setting[2] == 4) {List[1] = 1; List[3] = 1; checker = 1;}
        if(Setting[1] == 4) {List[2] = 1; List[3] = 1; checker = 1;}
    }
    if (checker == 1)
    {
        while(WhereComp == 0)
        {
            short RandomMove = random()%10 + 1;
            if (List[RandomMove] == 1) WhereComp = RandomMove;
        }
        return true;
    }
    else return false;
}


- (BOOL)CrossCheck;
{

    short CrossField = 0;

    if(Setting[1] == 0)
    {
        short LOfA11 = [self Row:1] + [self Row:4];
        short LOfA12 = [self Row:1] + [self Row:7];
        short LOfA13 = [self Row:4] + [self Row:7];
        
        if(LOfA11==8||LOfA12==8||LOfA13==8)
        {
            WhereComp = 1; CrossField++;
        }
    }

    if(Setting[2] == 0)
    {
        short LOfA2 = [self Row:1] + [self Row:5];
        
        if(LOfA2==8)
        {
            WhereComp = 2; CrossField++;
        }
    }

    if(Setting[3] == 0)
    {
        short LOfA31 = [self Row:1] + [self Row:6];
        short LOfA32 = [self Row:1] + [self Row:8];
        short LOfA33 = [self Row:6] + [self Row:8];
        
        if(LOfA31==8||LOfA32==8||LOfA33==8)
        {
            WhereComp = 3; CrossField++;
        }
    }

    if(Setting[4] == 0)
    {
        short LOfB1 = [self Row:2] + [self Row:4];
        
        if(LOfB1==8)
        {
            WhereComp = 4; CrossField++;
        }
    }

    if(Setting[6] == 0)
    {
        short LOfB3 = [self Row:2] + [self Row:6];
        
        if(LOfB3==8)
        {
            WhereComp = 6; CrossField++;
        }
    }
    
    if(Setting[7] == 0)
    {
        short LOfC11 = [self Row:3] + [self Row:4];
        short LOfC12 = [self Row:3] + [self Row:8];
        short LOfC13 = [self Row:4] + [self Row:8];
        
        if(LOfC11==8||LOfC12==8||LOfC13==8)
        {
            WhereComp = 7; CrossField++;
        }
    }
    
    if(Setting[8] == 0)
    {
        short LOfC2 = [self Row:3] + [self Row:5];
        
        if(LOfC2==8)
        {
            WhereComp = 8; CrossField++;
        }
    }

    if(Setting[9] == 0)
    {
        short LOfC31 = [self Row:3] + [self Row:6];
        short LOfC32 = [self Row:3] + [self Row:7];
        short LOfC33 = [self Row:6] + [self Row:7];
        
        if(LOfC31==8||LOfC32==8||LOfC33==8)
        {
            WhereComp = 9; CrossField++;
        }
    }

    if(CrossField == 1)
    {
        return true;
    }
    if(CrossField == 0)
    {
        return false;
    }
    if(CrossField > 1)
    {
        [self CrossFieldEvaluation];
        return true;
    }
    return false;
}


- (void)CrossFieldEvaluation;
{
    short List[4];
    short Length = 0;

    if(Setting[5] == 1)
    {
        if(Setting[2] == 0){List[Length] = 2; Length++;}
        if(Setting[4] == 0){List[Length] = 4; Length++;}
        if(Setting[6] == 0){List[Length] = 6; Length++;}
        if(Setting[8] == 0){List[Length] = 8; Length++;}
        WhereComp = List[random()%Length];
    }
    else
    {
        if(Setting[1]==1||Setting[9]==1){if(random()%2){WhereComp = 7;}else{WhereComp = 3;}}
        if(Setting[3]==1||Setting[7]==1){if(random()%2){WhereComp = 1;}else{WhereComp = 9;}}
    }
}

- (IBAction)ClearEntries:(id)sender
{
    Setting[0] = 0;
    Setting[1] = 0;
    Setting[2] = 0;
    Setting[3] = 0;
    Setting[4] = 0;
    Setting[5] = 0;
    Setting[6] = 0;
    Setting[7] = 0;
    Setting[8] = 0;
    Setting[9] = 0;
    MoveNumber = 0;
    if(PlayerBegins == YES)
    {
        PlayerBegins = NO;
        return;
    }
    else
    {
        PlayerBegins = YES;
        [self Move:0 User:4];
    }
}

- (short)Row:(short)Number
{
    if(Number == 1)
    {
        return (Setting[1] + Setting[2] + Setting[3]);
    }
    if(Number == 2)
    {
        return (Setting[4] + Setting[5] + Setting[6]);
    }
    if(Number == 3)
    {
        return (Setting[7] + Setting[8] + Setting[9]);
    }
    if(Number == 4)
    {
        return (Setting[1] + Setting[4] + Setting[7]);
    }
    if(Number == 5)
    {
        return (Setting[8] + Setting[5] + Setting[2]);
    }
    if(Number == 6)
    {
        return (Setting[9] + Setting[6] + Setting[3]);
    }
    if(Number == 7)
    {
        return (Setting[1] + Setting[5] + Setting[9]);
    }
    if(Number == 8)
    {
        return (Setting[7] + Setting[5] + Setting[3]);
    }
    return false;
}

- (BOOL)WinnerAlready
{

    if ([self Row:1] + [self Row:2] + [self Row:3] == 24 || [self Row:1] + [self Row:2] + [self Row:3] == 21)
    {
        short Result = 1;
        if (PlayerBegins)
            Result = Result + 3;
        [controller StatsPlusAt:Result];
        [controller Draw];
        return YES;
    }
    if ([self Row:1] == 12 || [self Row:2] == 12 || [self Row:3] == 12 || [self Row:4] == 12 || [self Row:5] == 12 || [self Row:6] == 12 || [self Row:7] == 12 || [self Row:8] == 12 || [self Row:9])
    {
        short Result = 2;
        if (PlayerBegins)
            Result = Result + 3;
        [controller StatsPlusAt:Result];
        [controller Win];
        return YES;
    }
    if ([self Row:1] == 3 || [self Row:2] == 3 || [self Row:3] == 3 || [self Row:4] == 3 || [self Row:5] == 3 || [self Row:6] == 3 || [self Row:7] == 3 || [self Row:8] == 3 || [self Row:9])
    {
        short Result = 3;
        if (PlayerBegins)
            Result = Result + 3;
        [controller StatsPlusAt:Result];
        [controller Lose];
        return YES;
    }
    return NO;
}

- (void)awakeFromNib
{
    PlayerBegins = NO;
}

@end
